#!/usr/local/bin/ruby

=begin
README: 

mgp2note.rbȯɽ˳ƥ饤ɰ˥ղä֤
htmlե뤿ΥġɸˤƤޤ
ŪˤȯɽƤʤɤ˥饤ɤɽȤ
ꤷƤޤ

mgpΥȤȤƼΤ褦ʸ

	%%begin_comment: Ȥκǽ
	%%	򤳤Τ褦ʸ˶ޤ줿ƤHTMLǰǤʤ
	%%	ʸHTMLѤѴ<PRE></PRE>Ȥɽ
	%%end_comment: ȤκǸ

Ϥե

	MGPDIR/images-index.html
	MGPDIR/mgp000xx.jpg.html (ե+".html")

USAGE:

˰ƤΤǥޥɥ饤ǰ褦ˤޤ
Ȥ"def usage()"դ򸫤Ƥ餦Ȥˤơ

1) tutorial-jp.mgp긵ˤ

	% ./mgp2note.rb -i -D slides tutorial-jp.mgp

2) tutorial-jp.mgp긵ˤäơ300x240βꤿ

	% ./mgp2note.rb -i -D slides -g 300x240 tutorial-jp.mgp

3) sample.mgpԽmgp2note.rbȤäindexľ
     "slides-sample"Ȥ̾Υǥ쥯ȥȤäƤ

	% ./mgp2note.rb -D slides-sample sample.mgp
=end

#
# processing argiment
#
load("parsearg.rb")
def usage()
  print <<EOF
Usage:
  mgp2note -i -g <geometry> -D <directory> <mgp file>

	-i) call mgp and produce jpeg (display image) files
	-g) set the image size with '-i' option (ex. 800x600)
	-t) use text agaist with the jpeg file
	-D) produce files into <directory>
EOF
  exit
end
$USAGE='usage'
parseArgs(1, "D", "tih", "D:", "g:")
# the option 'D' must be handle a directory name
# ARGV[0] must be the 'mgp' file name. now there is no error detection

#
# define static valiable
#
MGPDIR = $OPT_D
IMAGE_SUFFIX = "jpg"
MGPFILE = ARGV[0]

HTML_HEADER = <<HTML_HEADER
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN"
    "http://www.w3.org/TR/REC-html40/strict.dtd">
<HTML lang=ja>
<HEAD>
<TITLE>[MagicPoint] Presentation</TITLE>
<LINK rel="STYLESHEET" href="mgp2note.css" type="text/css">
<META http-equiv="Content-Type" content="text/html; charset=EUC-JP">
</HEAD>
<BODY>
HTML_HEADER

HTML_FOOTER = <<HTML_FOOTER
<DIV class="date">
<address>Yasuhiro Abe &lt;yasu@dengaku.org&gt;</address>
Created: #{Time.now.to_s}
</DIV>
</BODY></HTML>
HTML_FOOTER

#
# define class valiable
#
@images = Array.new
@images_num = 0
@css_update = true # after it must be set to FALSE

@page_comment = ""
@page_previous_comment = ""
@page_index = -1
@page_titles = Array.new
@page_state = 0
@page_fp = ""

#
# define functions
#
def guide_title
  # page title
  @page_fp << "#{@page_index}. #{@page_titles[@page_index-1]}\n<BR>"
  # goto previous page
  if @page_index - 2 < 0
    @page_fp << "Previous: START / "
  else
    @page_fp << "Previous: <A href=#{@images[@page_index-2]}.html>[#{@page_index-1}] #{@page_titles[@page_index.to_i-2]}</A> / "
  end
  # upto index page
  @page_fp << "Top: <A href=images-index.html>դ</A> / "
  # goto next page
  if @page_index  < @images_num
    @page_fp << "Next: <A href=#{@images[@page_index]}.html>[#{@page_index+1}] #{@page_titles[@page_index]}</A> / "
  else
    @page_fp << "Next: END / "
  end
  @page_fp << "<HR>\n"
end

def write_html(line)
  # INIT process per page
  print "Creating html file (#{@images[@page_index-1]}.html)\n"
  @page_fp = open(MGPDIR+File::Separator+@images[@page_index-1].to_s+".html", "w")
  # save page title
  @page_titles[@page_index] = line if ! line.empty?
  
  # produce HTML file
  # write header
  @page_fp << HTML_HEADER
  # added guide
  guide_title
  # draw viewgraph
  if $OPT_t && FileTest.exist?(MGPDIR+File::Separator+@images[@page_index-1].sub(IMAGE_SUFFIX,"txt"))
    @page_fp << "<DIV class=text><PRE>\n"
    File.foreach("|nkf -e "+MGPDIR+File::Separator+"#{@images[@page_index-1].sub(IMAGE_SUFFIX,'txt')}") { |line|
      @page_fp << line
    }
    @page_fp << "</PRE>\n"
  else
    @page_fp << "<DIV class=image><IMG src=" + @images[@page_index-1] +">\n"
  end
  @page_fp << "</DIV>\n"
  @page_fp << "<HR>\n"
end

def write_footer
  @page_fp << @page_previous_comment
  # added guide
  guide_title
  @page_fp << HTML_FOOTER
  # clean up process
  @page_index += 1
  @page_titles[@page_index] = ""
  @page_previous_comment = @page_comment
  @page_comment = ""
end

########
# main #
########
# checking and creating MGPDIR
if FileTest.directory?(MGPDIR)
  print "Reading "+MGPDIR+" directory...\n"
else
  print "Creating "+MGPDIR+"\n"
  Dir.mkdir(MGPDIR)
end
# (option) create image file
if $OPT_i
  if $OPT_g
    system("mgp -D "+$OPT_D+" -g "+$OPT_g+" "+MGPFILE)
  else
    system("mgp -D "+$OPT_D+" -g 800x600 "+MGPFILE)
  end
end
# creating image files list
Dir.foreach(MGPDIR) { |file|
  next if FileTest.directory?(file)
  if file =~ "mgp[0-9]{5,5}\.#{IMAGE_SUFFIX}$"
    # image file
    @images += file
  end
  @images_num = @images.size
}

# parse MGP file (with NKF to produce EUC stream)
open("|nkf -e "+MGPFILE).each_line{ |line|
  line.chop!

  # detect begin_comment directive
  if line =~ /^\%\%begin_comment/i
    @page_state = 1
    @page_comment << "<PRE>\n"
    next
  end

  if line =~ /^\%\%end_comment/i
    @page_state = 0
    @page_comment << "</PRE>\n"
    next
  end
  # when it's in the comment mode
  if @page_state == 1
    # processing for HTML
    line.sub!("^%%","")
    @page_comment <<  line + "\n"
    # add more operations!!
    next
  end

  # finding next page, write current page into a file, then goto next
  if line =~ /^\%page/i
    write_footer
    next
  end

  # skip blanks, comments, and directives
  if line =~ /^\%/ || line.empty?
    next
  elsif @page_index == 0 && ! line.empty? && @page_titles[@page_index].empty?
    @page_titles[@page_index] = line
    next
  elsif @page_titles[@page_index].empty?
    write_html(line)
  end
}
# write last page by hand
write_footer
write_html("")
write_footer

# create CSS file
if ! FileTest.exist?(MGPDIR+File::Separator+"mgp2note.css") || @css_update
  page_fp = open(MGPDIR+File::Separator+"mgp2note.css", "w")
  page_fp << <<EOF
BODY {
  background: #efefef;
  color: #8b475d;
  margin-left: 0.5em;
  margin-right: 0.5em;
}
H1 {
  text-align: center;
  color: midnightblue;
  margin-left: 0.1em;
}
PRE {
  margin-left:  2.0em;
  margin-right: 2.0em;
}
DIV.image {
  align: center;
}
DIV.text {
  text-align: right;
}
DIV.date {
  text-align: right;
  color: #197552;
}
DIV.top {
  text-align: right;
}
EOF
  page_fp.close
end

# create images list html file
@page_fp = open(MGPDIR+File::Separator+"images-list.html", "w")
@page_fp << HTML_HEADER
@page_fp << "<H1>#{@page_titles[0]}</H1>\n"
@page_fp << "<DIV class=top>image list | <A href=images-index.html>top page</A>\n"
@page_fp << " | <A href=index.html>mgp original index</A></DIV>\n"
@page_fp << "<HR>\n"
@images.each { |image|
  @page_fp << "	<A href=#{image}.html><IMG src=#{image.sub('jpg','idx.jpg')}></A>\n"
}
@page_fp << "<HR>\n"
@page_fp << "<DIV class=top>image list | <A href=images-index.html>top page</A>\n"
@page_fp << " | <A href=index.html>mgp original index</A></DIV>\n"
@page_fp << HTML_FOOTER

# create main-index html file
@page_fp = open(MGPDIR+File::Separator+"images-index.html", "w")
@page_fp << HTML_HEADER
@page_fp << "<H1>#{@page_titles[0]}</H1>"
@page_fp << "<DIV class=top><A href=images-list.html>image list</A>"
@page_fp << " | top page | <A href=index.html>mgp original index</A></DIV>"
@page_fp << "<HR>\n<OL>\n"
i = 0
@images.each {|image|
  @page_fp << "  <LI><A href=" + image + ".html>" + @page_titles[i] + "</A>\n"
  i += 1
}
@page_fp << "</OL>\n"
@page_fp << "<HR>\n"
@page_fp << "<DIV class=top><A href=images-list.html>image list</A>"
@page_fp << " | top page | <A href=index.html>mgp original index</A></DIV>"
@page_fp << HTML_FOOTER
